﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace DataBuildingList
{
    public partial class MainForm : Form
    {
        private IList<UserInfo> UserDatas = UserInfo.GetInitData();
        private BindingSource BindingUsers = new BindingSource();
        public MainForm()
        {
            InitializeComponent();
            //获取combo数据
            IList<string> categorys = UserDatas.Select(o => o.Category).Distinct().ToList();
            //绑定combo数据
            this.comboCategory.ComboBox.DataSource = categorys;
            //获取第一个类别的名称
            string category = categorys[0];
            //绑定数据
            DataBuilding(category);
            //绑定ListView数据
            this.listBox1.DataSource = BindingUsers;
            this.listBox1.DisplayMember = "Name";
            //绑定ID文本框数据
            this.txtId.DataBindings.Add("Text", BindingUsers, "Id");
            //绑定姓名文本框数据
            this.txtName.DataBindings.Add("Text", BindingUsers, "Name");
            //绑定地址文本框数据
            this.txtAddress.DataBindings.Add("Text", BindingUsers, "Address");
            //绑定是否责任人数据
            this.boxIsAdmin.DataBindings.Add("Checked", BindingUsers, "IsAdmin");
        }
        /// <summary>
        /// 将选中类别下面的数据显示在ListView中
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void comboCategory_SelectedIndexChanged(object sender, EventArgs e)
        {
            //获取选中的类别
            var category = this.comboCategory.Text;
            //绑定ListView数据
            DataBuilding(category);
        }
        /// <summary>
        /// 绑定ListView数据
        /// </summary>
        /// <param name="category"></param>
        private void DataBuilding(string category)
        {
            IList<UserInfo> listDatas = UserDatas.Where(o => o.Category == category).ToList();
            this.BindingUsers.DataSource = listDatas;
        }
        /// <summary>
        /// 新增
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void newToolStripButton_Click(object sender, EventArgs e)
        {
            AddUserForm userForm = new AddUserForm();
            if (userForm.ShowDialog() == DialogResult.Yes)
            {
                this.BindingUsers.Add(userForm.User);
            }
        }

        
    }
}
